/**
 * @implements {common/core/reducer/action}
 */
class ValidateCheckboxInputGroupAction
{
  constructor({
    checkboxInputGroupComposer,
    store
  })
  {
    this.store                      = store
    this.checkboxInputGroupComposer = checkboxInputGroupComposer
  }

  execute({ meta: { emitter, schema }, data: { value } })
  {
    const
    context    = this.store.getEntityContext(schema, emitter),
    newContext = this.checkboxInputGroupComposer.compose({
      ...context,
      value
    })

    return  this.store.addEntityContextToState(schema, newContext)
  }
}

module.exports = ValidateCheckboxInputGroupAction
